#ifndef have_Src_Zle_zle_keymap_globals
#define have_Src_Zle_zle_keymap_globals

extern Keymap curkeymap;
extern char*curkeymapname;
extern void scankeymap _((Keymap km,int sort,KeyScanFunc func,void*magic));
extern Keymap openkeymap _((char*name));
extern int selectkeymap _((char*name,int fb));
extern void reselectkeymap _((void));
extern int bindkey _((Keymap km,char*seq,Thingy bind,char*str));
extern Thingy keybind _((Keymap km,char*seq,char**strp));
extern int bin_bindkey _((char*name,char**argv,char*ops,int func));
extern void init_keymaps _((void));
extern void cleanup_keymaps _((void));
extern char*getkeymapcmd _((Keymap km,Thingy*funcp,char**strp));
extern void ungetkeycmd _((void));
extern Thingy getkeycmd _((void));

#endif /* !have_Src_Zle_zle_keymap_globals */

#ifndef GLOBAL_PROTOTYPES

static void createkeymapnamtab _((void));
static KeymapName makekeymapnamnode _((Keymap keymap));
static void freekeymapnamnode _((HashNode hn));
static HashTable newkeytab _((char*kmname));
static Key makekeynode _((Thingy t,char*str));
static void freekeynode _((HashNode hn));
static Keymap newkeymap _((Keymap tocopy,char*kmname));
static void scancopykeys _((HashNode hn,int flags));
static void deletekeymap _((Keymap km));
static void scankeys _((HashNode hn,int flags));
static int unlinkkeymap _((char*name));
static int linkkeymap _((Keymap km,char*name));
static int keyisprefix _((Keymap km,char*seq));
static int bin_bindkey_lsmaps _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static void scanlistmaps _((HashNode hn,int list));
static int bin_bindkey_delall _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_del _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_link _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_new _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_meta _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_bind _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static int bin_bindkey_list _((char*name,char*kmname,Keymap km,char**argv,char*ops,char func));
static void scanbindlist _((char*seq,Thingy bind,char*str,void*magic));
static void bindlistout _((struct bindstate*bs));
static void default_bindings _((void));
static int getkeybuf _((int w));

#endif /* !GLOBAL_PROTOTYPES */
