#ifndef have_Src_exec_globals
#define have_Src_exec_globals

extern int noerrexit;
extern int noerrs;
extern int nohistsave;
extern int errflag;
extern int trapreturn;
extern int subsh;
extern int retflag;
extern long lastval2;
extern char*fdtable;
extern int fdtable_size;
extern int max_zsh_fd;
extern int coprocin;
extern int coprocout;
extern int zleactive;
extern pid_t cmdoutpid;
extern int cmdoutval;
extern struct execstack*exstack;
extern List parse_string _((char*s));
extern struct rlimit current_limits[RLIM_NLIMITS];
extern struct rlimit limits[RLIM_NLIMITS];
extern int zsetlimit _((int limnum,char*nam));
extern int setlimits _((char*nam));
extern int list_pipe;
extern int simple_pline;
extern void execute _((Cmdnam not_used_yet,int dash));
extern char*findcmd _((char*arg0));
extern int iscom _((char*s));
extern int isrelative _((char*s));
extern Cmdnam hashcmd _((char*arg0,char**pp));
extern void execstring _((char*s,int dont_change_job,int exiting));
extern void execlist _((List list,int dont_change_job,int exiting));
extern void untokenize _((char*s));
extern void closem _((int how));
extern char*gethere _((char*str,int typ));
extern LinkList getoutput _((char*cmd,int qt));
extern char*getoutputfile _((char*cmd));
extern char*getproc _((char*cmd));
extern void doshfunc _((List list,LinkList doshargs,int flags,int noreturnval));
extern void execsave _((void));
extern void execrestore _((void));

#endif /* !have_Src_exec_globals */

#ifndef GLOBAL_PROTOTYPES

static pid_t zfork _((void));
static int execcursh _((Cmd cmd));
static int zexecve _((char*pth,char**argv));
static int isgooderr _((int e,char*dir));
static int execpline _((Sublist l,int how,int last1));
static void execpline2 _((Pline pline,int how,int input,int output,int last1));
static char**makecline _((LinkList list));
static int clobber_open _((struct redir*f));
static void closemn _((struct multio**mfds,int fd));
static void closemnodes _((struct multio**mfds));
static void closeallelse _((struct multio*mn));
static void addfd _((int forked,int*save,struct multio**mfds,int fd1,int fd2,int rflag));
static void addvars _((LinkList l,int export));
static void execcmd _((Cmd cmd,int input,int output,int how,int last1));
static void save_params _((Cmd cmd,LinkList*restore_p,LinkList*remove_p));
static void restore_params _((LinkList restorelist,LinkList removelist));
static void fixfds _((int*save));
static void entersubsh _((int how,int cl,int fake));
static int getherestr _((struct redir*fn));
static LinkList readoutput _((int in,int qt));
static List parsecmd _((char*cmd));
static int getpipe _((char*cmd));
static void mpipe _((int*pp));
static void spawnpipes _((LinkList l));
static int execcond _((Cmd cmd));
static int execarith _((Cmd cmd));
static int exectime _((Cmd cmd));
static int execfuncdef _((Cmd cmd));
static void execshfunc _((Cmd cmd,Shfunc shf));
static int execautofn _((Cmd cmd));
static List getfpfunc _((char*s));
static List stripkshdef _((List l,char*name));
static char*cancd _((char*s));
static int cancd2 _((char*s));

#endif /* !GLOBAL_PROTOTYPES */
