#ifndef have_Src_utils_globals
#define have_Src_utils_globals

extern void zwarnnam _((const char*cmd,const char*fmt,const char*str,int num));
extern char*scriptname;
extern void zerr _((const char*fmt,const char*str,int num));
extern void zerrnam _((const char*cmd,const char*fmt,const char*str,int num));
extern int putraw _((int c));
extern int putshout _((int c));
extern char*nicechar _((int c));
extern void nicefputs _((char*s,FILE*f));
extern size_t nicestrlen _((char*s));
extern char*findpwd _((char*s));
extern int ispwd _((char*s));
extern char*xsymlink _((char*s));
extern void print_if_link _((char*s));
extern void fprintdir _((char*s,FILE*f));
extern uid_t cached_uid;
extern char*cached_username;
extern char*get_username _((void));
extern Nameddir finddir _((char*s));
extern void adduserdir _((char*s,char*t,int flags,int always));
extern char*getnameddir _((char*name));
extern LinkList prepromptfns;
extern time_t lastmailcheck;
extern time_t lastwatch;
extern void preprompt _((void));
extern void freestr _((void*a));
extern void gettyinfo _((struct ttyinfo*ti));
extern void settyinfo _((struct ttyinfo*ti));
extern struct ttyinfo shttyinfo;
extern int resetneeded;
extern int winchanged;
extern void adjustwinsize _((void));
extern int movefd _((int fd));
extern void redup _((int x,int y));
extern int zclose _((int fd));
extern char*gettempname _((void));
extern int has_token _((const char*s));
extern void chuck _((char*str));
extern int tulower _((int c));
extern int tuupper _((int c));
extern void ztrncpy _((char*s,char*t,int len));
extern void strucpy _((char**s,char*t));
extern void struncpy _((char**s,char*t,int n));
extern int arrlen _((char**s));
extern int skipparens _((char inpar,char outpar,char**s));
extern long zstrtol _((const char*s,char**t,int base));
extern int checkrmall _((char*s));
extern int getquery _((char*valid_chars,int purge));
extern void spckword _((char**s,int hist,int cmd,int ask));
extern int ztrftime _((char*buf,int bufsize,char*fmt,struct tm*tm));
extern char*zjoin _((char**arr,int delim));
extern char**colonsplit _((char*s,int uniq));
extern char**spacesplit _((char*s,int allownull));
extern char*findword _((char**s,char*sep));
extern int wordcount _((char*s,char*sep,int mul));
extern char*sepjoin _((char**s,char*sep));
extern char**sepsplit _((char*s,char*sep,int allownull));
extern List getshfunc _((char*nam));
extern void*allocnode _((int type));
extern void*dupstruct _((void*a));
extern struct node*expandstruct _((struct node*n,int exp));
extern void freestruct _((void*a));
extern char**mkarray _((char*s));
extern void beep _((void));
extern void freearray _((char**s));
extern int equalsplit _((char*s,char**t));
extern void simplifyright _((List l));
extern short int typtab[256];
extern void inittyptab _((void));
extern char**arrdup _((char**s));
extern void setcbreak _((void));
extern void attachtty _((pid_t pgrp));
extern pid_t gettygrp _((void));
extern long getbaudrate _((struct ttyinfo*shttyinfo));
extern char*metafy _((char*buf,int len,int heap));
extern char*unmetafy _((char*s,int*len));
extern int metalen _((const char*s,int len));
extern char*unmeta _((const char*file_name));
extern int ztrcmp _((unsigned char const*s1,unsigned char const*s2));
extern int metadiffer _((char const*s,char const*r,int len));
extern int ztrlen _((char const*s));
extern int ztrsub _((char const*t,char const*s));
extern char*zreaddir _((DIR*dir,int ignoredots));
extern int zputs _((char const*s,FILE*stream));
extern char*niceztrdup _((char const*s));
extern int nicezputs _((char const*s,FILE*stream));
extern size_t niceztrlen _((char const*s));
extern int hasspecial _((char const*s));
extern int quotedzputs _((char const*s,FILE*stream));
extern char*dquotedztrdup _((char const*s));
extern int dquotedzputs _((char const*s,FILE*stream));
extern char*getkeystring _((char*s,int*len,int fromwhere,int*misc));
extern int strpfx _((char*s,char*t));
extern int strsfx _((char*s,char*t));
extern char*dupstrpfx _((const char*s,int len));
extern char*ztrduppfx _((const char*s,int len));
extern char*appstr _((char*base,char const*append));
extern int lchdir _((char const*path,struct dirsav*d,int hard));
extern int restoredir _((struct dirsav*d));
extern int getsignum _((char*s));
extern int privasserted _((void));
extern void dputs _((char*message));
extern int mode_to_octal _((mode_t mode));

#endif /* !have_Src_utils_globals */

#ifndef GLOBAL_PROTOTYPES

static char**slashsplit _((char*s));
static int xsymlinks _((char*s,int flag));
static void finddir_scan _((HashNode hn,int flags));
static int dircmp _((char*s,char*t));
static void checkmailpath _((char**s));
static void spscan _((HashNode hn,int scanflags));
static int skipwsep _((char**s));
static int findsep _((char**s,char*sep));
static struct node*simplifystruct _((struct node*n));
static void*dupstruct2 _((void*a));
static LinkList duplist _((LinkList l,VFunc func));
static char**duparray _((char**arr,VFunc func));
static char**list2arr _((LinkList l,VFunc func));
static LinkList arr2list _((char**arr,VFunc func));
static char*spname _((char*oldname));
static int mindist _((char*dir,char*mindistguess,char*mindistbest));
static int spdist _((char*s,char*t,int thresh));
static int upchdir _((int n));

#endif /* !GLOBAL_PROTOTYPES */
